<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout_baru}">
<head>
    <meta charset="UTF-8">
    <title>Kepuasan Pengguna</title>
</head>
<body>
<main layout:fragment="main" class="col-md-9 ms-sm-auto col-lg-10 px-md-4">
  <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
    <h4 class="h4">
      <span>Kepuasan Pengguna (Khusus program Diploma Tiga/Sarjana/Sarjana Terapan/Magister/Magister Terapan)</span>
    </h4>
  </div>
  <div class="row">
      <div class="col-md-12">
          <input type="hidden" id="prodiGet" th:value="${prodi.id}">
          <input type="hidden" id="tahunGet" th:value="${tahun}">
          <div class="card">
              <div class="card-header">
                  <div class="card-header-action" style="text-align: right;">
                      <!-- Button trigger modal -->
                      <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#exampleModal">
                          <i class="fa fa-plus-circle"></i> Tambah Data
                      </button>

                      <!-- Modal -->
                      <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                          <div class="modal-dialog">
                              <div class="modal-content">
                                  <form id="form-submit">
                                      <div class="modal-header">
                                          <h5 class="modal-title" id="exampleModalLabel">Tambah Data</h5>
                                          <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                      </div>
                                      <div class="modal-body" style="text-align: left;">
                                          <div class="form-group mb-3">
                                              <label>Jenis Kemampuan</label>
                                              <input type="text" class="form-control" name="jenisKemampuan" id="jenisKemampuan" required>
                                          </div>
                                          <hr>
                                          <div class="form-group mb-3">
                                              <b>Tingkat Kepuasan Pengguna (%)</b>
                                              <div class="row" style="margin-top: 5px;">
                                                  <div class="col-md-12 mb-3">
                                                      <label>Sangat Baik</label>
                                                      <input type="number" class="form-control" name="sangatBaik" id="sangatBaik">
                                                  </div>
                                                  <div class="col-md-12 mb-3">
                                                      <label>Baik</label>
                                                      <input type="number" class="form-control" name="baik" id="baik">
                                                  </div>
                                                  <div class="col-md-12 mb-3">
                                                      <label>Cukup</label>
                                                      <input type="number" class="form-control" name="cukup" id="cukup">
                                                  </div>
                                                  <div class="col-md-12 mb-3">
                                                      <label>Kurang</label>
                                                      <input type="number" class="form-control" name="kurang" id="kurang">
                                                  </div>
                                              </div>
                                          </div>
                                          <hr>
                                          <div class="form-group mb-3">
                                              <label>Rencana Tindak Lanjut oleh UPPS/PS</label>
                                              <input type="text" class="form-control" name="rencana" id="rencana">
                                          </div>
                                          <div class="form-group mb-3">
                                              <label>Kesesuaian dengan Target Profil Lulusan yang ditetapkan UPPS/PS</label>
                                              <input type="text" class="form-control" name="kesesuaian" id="kesesuaian">
                                              <input type="hidden" name="prodi" th:value="${prodi.getId()}" id="prodi">
                                              <input type="hidden" name="tahun" th:value="${tahun}" id="tahun">
                                          </div>
                                      </div>
                                      <div class="modal-footer">
                                          <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Tutup</button>
                                          <button type="button" onclick="saveData()" id="btn-save" class="btn btn-primary">Simpan</button>
                                      </div>
                                  </form>
                              </div>
                          </div>
                      </div>
                      <a th:href="@{/akreditasi(prodi = ${prodi.id}, tahun = ${tahun})}" class="btn btn-warning btn-sm"><i class="fa fa-arrow-circle-left"></i> Kembali</a>
                  </div>
              </div>
              <div class="card-body">
                  <div class="table-responsive">
                      <div id="success"></div>
                      <table id="noteTable" class="table table-striped table-bordered">
                          <thead>
                          <tr>
                              <th rowspan="2">#</th>
                              <th rowspan="2">Jenis Kemampuan</th>
                              <th colspan="4">Jumlah Lulusan Terlacak yang Bekerja berdasarkan Tingkat/Ukuran Tempat Kerja/Berwirausaha</th>
                              <th rowspan="2">Rencana Tindak Lanjut oleh UPPS/PS</th>
                              <th rowspan="2">Kesesuaian dengan Target Profil Lulusan yang ditetapkan UPPS/PS</th>
                              <th rowspan="2"></th>
                          </tr>
                          <tr>
                              <th>
                                  Sangat Baik
                              </th>
                              <th>
                                  Baik
                              </th>
                              <th>
                                  Cukup
                              </th>
                              <th>
                                  Kurang
                              </th>
                          </tr>
                          </thead>
                          <tbody>

                          </tbody>
                          <tfoot>

                          </tfoot>
                      </table>

                      <ul class="pagination justify-content-center" style="margin:20px 0; cursor: pointer;">
                      </ul>

                  </div>
              </div>
          </div>
      </div>
  </div>
</main>
<section layout:fragment="footer">
    <script type="text/javascript">
        function saveData(){
            $.ajaxSetup({
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="_csrf"]').attr('content')
                }
            });
            $.ajax({
                url: 'api/post/kepuasan',
                type: 'POST',
                data: $('#form-submit').serialize(),
                dataType: "json",
                success: function (response){
                    $('#exampleModal').modal('hide');
                    getData(0);
                    $("#form-submit")[0].reset();
                    Swal.fire(
                        'Good job!',
                        'Data berhasil disimpan',
                        'success'
                    )
                }
            })
        }

        function deleteData(id){
            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                if (result.isConfirmed) {
                    $.ajaxSetup({
                        headers: {
                            'X-CSRF-TOKEN': $('meta[name="_csrf"]').attr('content')
                        }
                    });
                    $.ajax({
                        url:'api/delete/kepuasan?id=' + id,
                        type: 'GET',
                        success: function (){
                            getData(0);
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                        }
                    })
                }
            })
        }

        let totalPages = 1;
        function getData(startPage) {
            console.log('startPage: ' +startPage);
            /**
             * get data from Backend's REST API
             */
            var prodi = document.getElementById('prodiGet').value;
            var tahun = document.getElementById('tahunGet').value;
            $.ajax({
                type : "GET",
                url : "api/get/kepuasan?prodi=" + prodi + "&tahun=" + tahun,
                data: {
                    page: startPage,
                    size: 10
                },
                success: function(response){
                    $('#noteTable tbody').empty();

                    // add table rows
                    $.each(response.data.content, (i, note) => {
                        var a = i + 1;
                        let noteRow = '<tr>' +
                            '<td>' + a + '</td>' +
                            '<td>' + note.jenisKemampuan + '</td>' +
                            '<td>' + note.sangatBaik + '</td>' +
                            '<td>' + note.baik + '</td>' +
                            '<td>' + note.cukup + '</td>' +
                            '<td>' + note.kurang + '</td>' +
                            '<td>' + note.rencana + '</td>' +
                            '<td>' + note.kesesuaian + '</td>' +
                            '<td><a onclick="deleteData(\'' + note.id + '\');" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></a></td>' +
                            '</tr>';
                        $('#noteTable tbody').append(noteRow);
                    });

                    if ($('ul.pagination li').length - 2 != response.totalPages){
                        // build pagination list at the first time loading
                        $('ul.pagination').empty();
                        buildPagination(response);
                    }
                },
                error : function(e) {
                    alert("ERROR: ", e);
                    console.log("ERROR: ", e);
                }
            });
        }

        function buildPagination(response) {
            totalPages = response.data.totalPages;

            var pageNumber = response.data.pageable.pageNumber;

            var numLinks = 10;

            // print 'previous' link only if not on page one
            var first = '';
            var prev = '';
            if (pageNumber > 0) {
                if(pageNumber !== 0) {
                    first = '<li class="page-item"><a class="page-link">« First</a></li>';
                }
                prev = '<li class="page-item"><a class="page-link">‹ Prev</a></li>';
            } else {
                prev = ''; // on the page one, don't show 'previous' link
                first = ''; // nor 'first page' link
            }

            // print 'next' link only if not on the last page
            var next = '';
            var last = '';
            if (pageNumber < totalPages) {
                if(pageNumber !== totalPages - 1) {
                    next = '<li class="page-item"><a class="page-link">Next ›</a></li>';
                    last = '<li class="page-item"><a class="page-link">Last »</a></li>';
                }
            } else {
                next = ''; // on the last page, don't show 'next' link
                last = ''; // nor 'last page' link
            }

            var start = pageNumber - (pageNumber % numLinks) + 1;
            var end = start + numLinks - 1;
            end = Math.min(totalPages, end);
            var pagingLink = '';

            for (var i = start; i <= end; i++) {
                if (i == pageNumber + 1) {
                    pagingLink += '<li class="page-item active"><a class="page-link"> ' + i + ' </a></li>'; // no need to create a link to current page
                } else {
                    pagingLink += '<li class="page-item"><a class="page-link"> ' + i + ' </a></li>';
                }
            }

            // return the page navigation link
            pagingLink = first + prev + pagingLink + next + last;

            $("ul.pagination").append(pagingLink);
        }

        $(document).on("click", "ul.pagination li a", function() {
            var data = $(this).attr('data');
            let val = $(this).text();
            console.log('val: ' + val);

            // click on the NEXT tag
            if(val.toUpperCase() === "« FIRST") {
                let currentActive = $("li.active");
                getData(0);
                $("li.active").removeClass("active");
                // add .active to next-pagination li
                currentActive.next().addClass("active");
            } else if(val.toUpperCase() === "LAST »") {
                getData(totalPages - 1);
                $("li.active").removeClass("active");
                // add .active to next-pagination li
                currentActive.next().addClass("active");
            } else if(val.toUpperCase() === "NEXT ›") {
                let activeValue = parseInt($("ul.pagination li.active").text());
                if(activeValue < totalPages){
                    let currentActive = $("li.active");
                    startPage = activeValue;
                    getData(startPage);
                    // remove .active class for the old li tag
                    $("li.active").removeClass("active");
                    // add .active to next-pagination li
                    currentActive.next().addClass("active");
                }
            } else if(val.toUpperCase() === "‹ PREV") {
                let activeValue = parseInt($("ul.pagination li.active").text());
                if(activeValue > 1) {
                    // get the previous page
                    startPage = activeValue - 2;
                    getData(startPage);
                    let currentActive = $("li.active");
                    currentActive.removeClass("active");
                    // add .active to previous-pagination li
                    currentActive.prev().addClass("active");
                }
            } else {
                startPage = parseInt(val - 1);
                console.log('Test : ' + startPage);
                getData(startPage);
                // add focus to the li tag
                $("li.active").removeClass("active");
                $(this).parent().addClass("active");
                //$(this).addClass("active");
            }
        });

        (function(){
            // get first-page at initial time
            getData(0);
        })();
    </script>
</section>
</body>
</html>